//credits: monorogu and foxino
import { world } from '@minecraft/server';

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('ry:block_connect', {
        onPlace(e) {
            const { block } = e;
            const north = block.north();
            const south = block.south();
            const west = block.west();
            const east = block.east();
            const tags = block.getTags();

            const hasCommonTag = (blockState) => {
                const neighborTags = blockState.getTags();
                return tags.some(tag => tag != 'ry_table' && neighborTags.includes(tag));
            };

            if (north && hasCommonTag(north)) {
                north.setPermutation(north.permutation.withState('ry:south_neighbor', 1));
                block.setPermutation(block.permutation.withState('ry:north_neighbor', 1));
            }
            if (south && hasCommonTag(south)) {
                south.setPermutation(south.permutation.withState('ry:north_neighbor', 1));
                block.setPermutation(block.permutation.withState('ry:south_neighbor', 1));
            }
            if (west && hasCommonTag(west)) {
                west.setPermutation(west.permutation.withState('ry:east_neighbor', 1));
                block.setPermutation(block.permutation.withState('ry:west_neighbor', 1));
            }
            if (east && hasCommonTag(east)) {
                east.setPermutation(east.permutation.withState('ry:west_neighbor', 1));
                block.setPermutation(block.permutation.withState('ry:east_neighbor', 1));
            }
        }
    });
});
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('ry:block_connect_destroy', {
        onPlayerDestroy(e) {
            const { block } = e;
            const north = block.north();
            const south = block.south();
            const west = block.west();
            const east = block.east();

            if (north) {
                const statenorth = north.permutation.getState('ry:south_neighbor');
                if (statenorth) {
                    north.setPermutation(north.permutation.withState('ry:south_neighbor', 0));
                }
            }

            if (south) {
                const statesouth = south.permutation.getState('ry:north_neighbor');
                if (statesouth) {
                    south.setPermutation(south.permutation.withState('ry:north_neighbor', 0));
                }
            }

            if (west) {
                const statewest = west.permutation.getState('ry:east_neighbor');
                if (statewest) {
                    west.setPermutation(west.permutation.withState('ry:east_neighbor', 0));
                }
            }

            if (east) {
                const stateeast = east.permutation.getState('ry:west_neighbor');
                if (stateeast) {
                    east.setPermutation(east.permutation.withState('ry:west_neighbor', 0));
                }
            }
        }
    });
});