//Credit: Shxdow
import { ActionFormData, ModalFormData, MessageFormData } from '@minecraft/server-ui';
import { world, system } from '@minecraft/server';


world.beforeEvents.playerInteractWithBlock.subscribe((eventData) => {
    let { player, block, isFirstEvent } = eventData;
    if (!isFirstEvent) { eventData.cancel = false; return; }
    system.run(() => {
        if (block.typeId === 'ry:computer')
            secureContain(player);
    });
});


function secureContain(player) {
    let form = new ActionFormData()
        .title("Secure Contain Protect")
        .body("")
        .button("SCPs Information", "textures/ui/sa_scp_logo1")
        .button("Message App", "textures/ui/sa_scp999")
        .button("Credits", "textures/ui/sa_scp173_u")
        .button("Soon", "textures/ui/sa_scp173v2")
        .show(player).then(res => {
            if (res.canceled) return;

            if (res.selection == 0) {
                scpInformation(player);
            }
            if (res.selection == 1) {
                messageApp(player);
            }
            if (res.selection == 2) {
                credits(player);
            }
            if (res.selection == 3) {
                player.onScreenDisplay.setActionBar("ยง4More update soon!");
            }
        })
}

function messageApp(player) {
    let form2 = new ModalFormData()
        .title("Message App")
        .textField("Message", "Type your message here")
        .show(player).then(res => {
            if (res.canceled) return;
            player.sendMessage(`Server: ${JSON.stringify(res.formValues, undefined, 2)}`);
        })
}

function scpInformation(player) {
    let form3 = new ActionFormData()
        .title("SCPs Information")
        .body("")
        .button("SCP-173", "textures/ui/sa_scp173")
        .button("SCP-049", "textures/ui/sa_scp049")
        .button("SCP-939", "textures/ui/sa_scp939")
        .button("SCP-811", "textures/ui/sa_scp811")
        .button("SCP-173-U", "textures/ui/sa_scp173_u")
        .button("SCP-173-V2", "textures/ui/sa_scp173v2")
        .button("SCP-682", "textures/ui/sa_scp682")
        .button("SCP-999", "textures/ui/sa_scp999")
        .button("SCP-098", "textures/ui/sa_scp098")
        .show(player).then(res => {
            if (res.canceled) return;

            if (res.selection == 0) {
                informationScp1(player);

            }
            if (res.selection == 1) {
                informationScp2(player);

            }
            if (res.selection == 2) {
                informationScp3(player);

            }
            if (res.selection == 3) {
                informationScp4(player);

            }
            if (res.selection == 4) {
                informationScp1(player);
            }
            if (res.selection == 5) {
                informationScp1(player);
            }
            if (res.selection == 6) {
                informationScp5(player);
            }
            if (res.selection == 7) {
                informationScp6(player);
            }
            if (res.selection == 8) {
                informationScp7(player);
            }
        })
}

function credits(player) {
    let form4 = new MessageFormData()
        .title("Credits")
        .body("-Author: Rynnn/RianDewa45\n -Creator: Rynnn/RianDewa45\n -Models: Rynnn/RianDewa45 and Cypdo\n -Textures: Rynnn/RianDewa45, Chypdo and IMMoOocus\n -Codes (Scripts): (read every top of the scripts)\n -Inspiration: SCP Foundation and Sketchfab")
        .button1("Ok")
        .button2("Cancel")
        .show(player).then(res => {
            if (res.canceled) return;
        })
}

function informationScp1(player) {
    let form5 = new ActionFormData()
        .title("Special Containment Procedure")
        .body("")
        .button("SCP-173 The Sculpture\n       Class: Euclid", "textures/ui/display/ry_sa_scp173_base")
        .button("", "textures/ui/text/173_text")
        .show(player).then(res => {
            if (res.canceled) return;

            if (res.selection == 0) {
                player.onScreenDisplay.setActionBar("More info: https://scp-wiki.wikidot.com/scp-173");
            }
            if (res.selection == 1) {
                player.onScreenDisplay.setActionBar("More info: https://scp-wiki.wikidot.com/scp-173")
            }
        })
}

function informationScp2(player) {
    let form5 = new ActionFormData()
        .title("Special Containment Procedure")
        .body("")
        .button("SCP-049 The Doctor\n     Class: Euclid", "textures/ui/display/ry_sa_scp049")
        .button("", "textures/ui/text/049_text")
        .show(player).then(res => {
            if (res.canceled) return;

            if (res.selection == 0) {
                player.onScreenDisplay.setActionBar("More info: https://scp-wiki.wikidot.com/scp-049");
            }
            if (res.selection == 1) {
                player.onScreenDisplay.setActionBar("More info: https://scp-wiki.wikidot.com/scp-049")
            }
        })
}

function informationScp3(player) {
    let form5 = new ActionFormData()
        .title("Special Containment Procedure")
        .body("")
        .button("SCP-939 With Many Voices\n        Class: Keter", "textures/ui/display/ry_sa_scp939")
        .button("", "textures/ui/text/939_text")
        .show(player).then(res => {
            if (res.canceled) return;

            if (res.selection == 0) {
                player.onScreenDisplay.setActionBar("More info: https://scp-wiki.wikidot.com/scp-939");
            }
            if (res.selection == 1) {
                player.onScreenDisplay.setActionBar("More info: https://scp-wiki.wikidot.com/scp-939")
            }
        })
}

function informationScp4(player) {
    let form5 = new ActionFormData()
        .title("Special Containment Procedure")
        .body("")
        .button("SCP-811 Swamp Woman\n     Class: Euclid", "textures/ui/display/ry_sa_scp811")
        .button("", "textures/ui/text/811_text")
        .show(player).then(res => {
            if (res.canceled) return;

            if (res.selection == 0) {
                player.onScreenDisplay.setActionBar("More info: https://scp-wiki.wikidot.com/scp-811");
            }
            if (res.selection == 1) {
                player.onScreenDisplay.setActionBar("More info: https://scp-wiki.wikidot.com/scp-811")
            }
        })
}

function informationScp5(player) {
    let form5 = new ActionFormData()
        .title("Special Containment Procedure")
        .body("")
        .button("SCP-682 Hard-to-Destroy\n         Class: Keter", "textures/ui/display/ry_sa_scp682_reptile")
        .button("", "textures/ui/text/682_text")
        .show(player).then(res => {
            if (res.canceled) return;

            if (res.selection == 0) {
                player.onScreenDisplay.setActionBar("More info: https://scp-wiki.wikidot.com/scp-682");
            }
            if (res.selection == 1) {
                player.onScreenDisplay.setActionBar("More info: https://scp-wiki.wikidot.com/scp-682")
            }
        })
}

function informationScp6(player) {
    let form5 = new ActionFormData()
        .title("Special Containment Procedure")
        .body("")
        .button("SCP-999 Tickle Monster\n     Class: Safe", "textures/ui/display/ry_sa_scp999")
        .button("", "textures/ui/text/999_text")
        .show(player).then(res => {
            if (res.canceled) return;

            if (res.selection == 0) {
                player.onScreenDisplay.setActionBar("More info: https://scp-wiki.wikidot.com/scp-999");
            }
            if (res.selection == 1) {
                player.onScreenDisplay.setActionBar("More info: https://scp-wiki.wikidot.com/scp-999")
            }
        })
}

function informationScp7(player) {
    let form5 = new ActionFormData()
        .title("Special Containment Procedure")
        .body("")
        .button("SCP-098 Surgeon Crab\n     Class: Safe", "textures/ui/display/ry_sa_scp098")
        .button("", "textures/ui/text/098_text")
        .show(player).then(res => {
            if (res.canceled) return;

            if (res.selection == 0) {
                player.onScreenDisplay.setActionBar("More info: https://scp-wiki.wikidot.com/scp-098");
            }
            if (res.selection == 1) {
                player.onScreenDisplay.setActionBar("More info: https://scp-wiki.wikidot.com/scp-098")
            }
        })
}