//credits: GST378
import { world } from '@minecraft/server';

const EntityRotations = { north: 0, east: 90, south: 180, west: 270 };
const sitOnBlock = {
    onPlayerInteract({ block, player }) {
        const seatEntity = block.dimension.spawnEntity("ry:seat", { x: block.x + 0.5, y: block.y - 0.5, z: block.z + 0.5 });
        if (!seatEntity) return;
        seatEntity.setRotation({ x: 0, y: EntityRotations[block.permutation.getState('minecraft:cardinal_direction')] });
        const rideableComp = seatEntity.getComponent("minecraft:rideable");
        if (!rideableComp) return;
        rideableComp.addRider(player);
    }
}

world.beforeEvents.worldInitialize.subscribe((eventData) => {
    eventData.blockComponentRegistry.registerCustomComponent('ry:seat', sitOnBlock);
});