import { world } from "@minecraft/server";


const BlockCustomTrapdoorComponent = {
    onPlayerInteract({ block, dimension }) {
        const isOpen = block.permutation.getState("ry:open");
        const sound = isOpen ? "close.wooden_trapdoor" : "open.wooden_trapdoor";

        block.setPermutation(block.permutation.withState("ry:open", !isOpen));

        dimension.playSound(sound, block.center(), {
            pitch: 0.9,
            volume: 0.9,
        });
    },
};

world.beforeEvents.worldInitialize.subscribe(({ blockComponentRegistry }) => {
    blockComponentRegistry.registerCustomComponent(
        "ry:vent",
        BlockCustomTrapdoorComponent
    );
});